SystemOrganization addCategory: #'SqueakEv-Demo'!

Object subclass: #Blog
	instanceVariableNames: 'title blogPosts'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakEv-Demo'!

!Blog methodsFor: 'accessing' stamp: 'tkow 3/13/2009 13:50'!
blogPosts
	^ blogPosts! !

!Blog methodsFor: 'accessing' stamp: 'tkow 3/12/2009 20:39'!
blogPosts: anObject
	blogPosts := anObject! !

!Blog methodsFor: 'accessing' stamp: 'tkow 3/13/2009 10:33'!
initialize
	super initialize.
	blogPosts := OrderedCollection new.! !

!Blog methodsFor: 'accessing' stamp: 'tkow 3/12/2009 20:39'!
title
	^ title! !

!Blog methodsFor: 'accessing' stamp: 'tkow 3/12/2009 20:39'!
title: anObject
	title := anObject! !

Object subclass: #BlogComment
	instanceVariableNames: 'title name text'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakEv-Demo'!

!BlogComment class methodsFor: 'as yet unclassified' stamp: 'tkow 3/13/2009 11:39'!
descriptionName
	^ (MAStringDescription selector: #name label: 'Name' priority: 10)
		yourself ! !

!BlogComment class methodsFor: 'as yet unclassified' stamp: 'tkow 3/13/2009 11:40'!
descriptionText
	^ (MAMemoDescription selector: #text label: 'Text' priority: 20)
		beRequired;
		yourself ! !

!BlogComment class methodsFor: 'as yet unclassified' stamp: 'tkow 3/13/2009 11:40'!
descriptionTitle
	^ (MAStringDescription selector: #title label: 'Title' priority: 10)
		beRequired;
		yourself ! !

!BlogComment methodsFor: 'accessing' stamp: 'tkow 3/13/2009 11:43'!
name
	^ name! !

!BlogComment methodsFor: 'accessing' stamp: 'tkow 3/13/2009 11:43'!
name: anObject
	name := anObject! !

!BlogComment methodsFor: 'accessing' stamp: 'tkow 3/13/2009 11:43'!
text
	^ text! !

!BlogComment methodsFor: 'accessing' stamp: 'tkow 3/13/2009 11:43'!
text: anObject
	text := anObject! !

!BlogComment methodsFor: 'accessing' stamp: 'tkow 3/13/2009 11:43'!
title
	^ title! !

!BlogComment methodsFor: 'accessing' stamp: 'tkow 3/13/2009 11:43'!
title: anObject
	title := anObject! !

Object subclass: #BlogPost
	instanceVariableNames: 'title text comments'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakEv-Demo'!

!BlogPost class methodsFor: 'as yet unclassified' stamp: 'tkow 3/13/2009 10:44'!
descriptionText
	^ (MAMemoDescription selector: #text label: 'Text' priority: 20)
		beRequired;
		yourself! !

!BlogPost class methodsFor: 'as yet unclassified' stamp: 'tkow 3/13/2009 10:44'!
descriptionTitle
	^ (MAStringDescription selector: #title label: 'Title' priority: 10)
		beRequired;
		yourself! !

!BlogPost methodsFor: 'accessing' stamp: 'tkow 3/12/2009 20:38'!
comments
	^ comments! !

!BlogPost methodsFor: 'accessing' stamp: 'tkow 3/12/2009 20:38'!
comments: anObject
	comments := anObject! !

!BlogPost methodsFor: 'initialization' stamp: 'tkow 3/13/2009 10:33'!
initialize
	super initialize.
	comments := OrderedCollection new.! !

!BlogPost methodsFor: 'accessing' stamp: 'tkow 3/12/2009 20:38'!
text
	^ text! !

!BlogPost methodsFor: 'accessing' stamp: 'tkow 3/12/2009 20:38'!
text: anObject
	text := anObject! !

!BlogPost methodsFor: 'accessing' stamp: 'tkow 3/12/2009 20:38'!
title
	^ title! !

!BlogPost methodsFor: 'accessing' stamp: 'tkow 3/12/2009 20:38'!
title: anObject
	title := anObject! !

Object subclass: #User
	instanceVariableNames: 'username password email'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakEv-Demo'!

User class
	uses: TSqsSearch
	instanceVariableNames: ''!

User subclass: #Admin
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakEv-Demo'!

User subclass: #Author
	instanceVariableNames: 'blog'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakEv-Demo'!

!Author methodsFor: 'accessing' stamp: 'tkow 3/13/2009 10:31'!
blog
	^ blog! !

!Author methodsFor: 'accessing' stamp: 'tkow 3/13/2009 10:31'!
blog: anObject
	blog := anObject! !

!Author methodsFor: 'as yet unclassified' stamp: 'tkow 3/13/2009 10:56'!
initialize
	super initialize.
	blog := Blog new
		title: 'MyBlog';
		yourself! !

!User methodsFor: 'accessing' stamp: 'tkow 3/12/2009 20:37'!
email
	^ email! !

!User methodsFor: 'accessing' stamp: 'tkow 3/12/2009 20:37'!
email: anObject
	email := anObject! !

!User methodsFor: 'as yet unclassified' stamp: 'tkow 3/13/2009 10:56'!
initialize
	super initialize.
! !

!User methodsFor: 'accessing' stamp: 'tkow 3/12/2009 20:37'!
password
	^ password! !

!User methodsFor: 'accessing' stamp: 'tkow 3/12/2009 20:37'!
password: anObject
	password := anObject! !

!User methodsFor: 'accessing' stamp: 'tkow 3/12/2009 20:37'!
username
	^ username! !

!User methodsFor: 'accessing' stamp: 'tkow 3/12/2009 20:37'!
username: anObject
	username := anObject! !

WAComponent subclass: #BlogView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakEv-Demo'!

!BlogView class methodsFor: 'as yet unclassified' stamp: 'tkow 3/13/2009 10:46'!
canBeRoot
	^ true! !

!BlogView methodsFor: 'rendering' stamp: 'tkow 3/13/2009 11:47'!
addCommentTo: aPost
	| comment |
	comment := self call: (BlogComment new asComponent addValidatedForm; yourself).
	comment ifNotNil: [
		aPost comments add: comment.
		aPost deepSave.	
	]! !

!BlogView methodsFor: 'as yet unclassified' stamp: 'tkow 3/13/2009 11:37'!
newPost
	| post |
	post := self call: (BlogPost new asComponent addValidatedForm; yourself).
	post ifNotNil: [
		self session user blog blogPosts add: post.
		self session user blog save.	
	]! !

!BlogView methodsFor: 'rendering' stamp: 'tkow 3/13/2009 13:49'!
renderBlogOverviewOn: html
	| |
	self session user blog blogPosts reversed do: [:aPost |
		html div: [
			html heading: aPost title level: 2; text: aPost text.
			html div: [html heading: 'Comments' level: 3.
				aPost comments do: [:aComment |
					html heading: aComment title level: 4; text: aComment text	
				]
			] 
		].
		(html anchor) callback: [self addCommentTo: aPost]; text: 'Add comment'.
	].
	html break.
	html anchor on: #newPost of: self.! !

!BlogView methodsFor: 'rendering' stamp: 'tkow 3/13/2009 10:36'!
renderContentOn: html

	self session user ifNil: [
		html heading: 'Please run the migration first to create a test user'.	
	] ifNotNil: [
		self renderBlogOverviewOn: html
	].! !

WASession subclass: #BlogViewSession
	instanceVariableNames: 'user'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakEv-Demo'!

!BlogViewSession methodsFor: 'as yet unclassified' stamp: 'tkow 3/13/2009 11:08'!
initialize
	super initialize.
	self user: ((SqsSearch for: Author) findByUsername: 'test').! !

!BlogViewSession methodsFor: 'accessing' stamp: 'tkow 3/7/2009 10:43'!
user
	^ user! !

!BlogViewSession methodsFor: 'accessing' stamp: 'tkow 3/7/2009 10:43'!
user: anObject
	user := anObject! !

SqsMigration subclass: #BlogMigration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakEv-Demo'!

!BlogMigration class methodsFor: 'persistence-description' stamp: ''!
sqsDescrVersion
	^ SqsColumn new manuallyMaintained: false;
		 columnName: 'version';
		 sqlType: #string;
		 objectClass: #ByteString;
		 tableName: 'schema_migrations';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'version';
		 yourself! !

!BlogMigration methodsFor: 'downwards-migrations' stamp: 'tkow 3/13/2009 10:49'!
createTestUserDown
	<version: '2009-03-13T10:49:22.792+00:00'>! !

!BlogMigration methodsFor: 'upwards-migrations' stamp: 'tkow 3/13/2009 13:48'!
createTestUserUp
	<version: '2009-03-13T10:49:22.792+00:00'>
	| user |
	user := Author new
		username: 'test';
		email: 'test@deutschland.de';
		password: 'geheim';
		yourself.
		
	user deepSave.! !

SqsConfig subclass: #SqueakEvSqsConfig
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakEv-Demo'!

!SqueakEvSqsConfig class methodsFor: 'as yet unclassified' stamp: 'tkow 3/13/2009 10:51'!
connectionSpecification
	^ SqsMySQLConnectionSpecification user: 'test' password: 'test' database: 'squeak_ev_demo'! !
